unit U_principal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, BarraLateral, StdCtrls, DBCtrls, ComCtrls, ExtCtrls, Mask,
  Grids, DBGrids, TFlatSpeedButtonUnit, TFlatButtonUnit, CoolTrayIcon,
  Menus, TFlatEditUnit,ShellApi,IniFiles, Registry, DB, DBTables,
  TFlatProgressBarUnit, IBCustomDataSet, IBQuery, IBDatabase, RxMenus,
  Buttons;

type
  Tfrm_principal = class(TForm)
    memo_descricao: TDBMemo;
    img_close0: TImage;
    BarraLateral1: TBarraLateral;
    label_cont: TLabel;
    grid1: TDBGrid;
    DBText1: TDBText;
    Label1: TLabel;
    timerMemoria: TTimer;
    fbCal: TFlatButton;
    Calendario: TMonthCalendar;
    fsbMen: TFlatSpeedButton;
    Timer_alpha: TTimer;
    TIcon: TCoolTrayIcon;
    PopupMenu1: TPopupMenu;
    Sair1: TMenuItem;
    fb_ativo: TFlatSpeedButton;
    fb_inativo: TFlatSpeedButton;
    FlatSpeedButton1: TFlatSpeedButton;
    pbar_memoria: TFlatProgressBar;
    label_memoria: TLabel;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    qry_eventos: TIBQuery;
    ds_eventos: TDataSource;
    qry_eventos2: TIBQuery;
    ds_eventos2: TDataSource;
    ppmAdd: TRxPopupMenu;
    AddEvento1: TMenuItem;
    AddAniver1: TMenuItem;
    ExcluirEvento1: TMenuItem;
    FlatButton1: TFlatButton;
    Alterardata1: TMenuItem;
    IBDatabase2: TDatabase;
    qry_eventos_: TQuery;
    qry_eventos2_: TQuery;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    Session1: TSession;
    FlatButton2: TFlatButton;
    pmenGrid: TPopupMenu;
    Exportar1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure grid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure FormShow(Sender: TObject);
    procedure timerMemoriaTimer(Sender: TObject);
    procedure fbCalClick(Sender: TObject);
    procedure fsbMenClick(Sender: TObject);
    procedure Timer_alphaTimer(Sender: TObject);
    procedure grid1CellClick(Column: TColumn);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure Sair1Click(Sender: TObject);
    procedure TIconClick(Sender: TObject);
    procedure fb_ativoClick(Sender: TObject);
    procedure fb_inativoClick(Sender: TObject);
    procedure CalendarioClick(Sender: TObject);
    procedure AddEvento1Click(Sender: TObject);
    procedure CalendarioGetMonthInfo(Sender: TObject; Month: Cardinal;
      var MonthBoldInfo: Cardinal);
    procedure ExcluirEvento1Click(Sender: TObject);
    procedure FlatButton1Click(Sender: TObject);
    procedure Alterardata1Click(Sender: TObject);
    procedure FlatButton2Click(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
  end;

var
  frm_principal: Tfrm_principal;
  reg : TRegIniFile;
  ativo : boolean;

implementation
uses U_data, U_niver, U_addEvento, U_alteradata;

{$R *.dfm}



procedure Tfrm_principal.FormCreate(Sender: TObject);
var
    rgn,rgn1:Thandle;
begin
     Rgn:=CreateRoundRectRgn(0,0,616,210,40,40);
     Rgn1:=CreateRoundRectRgn(0,226,200,335,40,40);
     //CreateRoundRectRgn( X0, Y0, X1, Y1, SenTop x, SenTop Y)
     CombineRgn(Rgn,Rgn,Rgn1,Rgn_OR);
     SetWindowRgn(Handle,Rgn,True);
     DeleteObject(Rgn1);
     //Data atual
     calendario.Date := date;

     //MinimizeToSystemTray;
    tIcon.MinimizeToTray := true;
    tIcon.Enabled := true;
    application.Minimize;
    
    //timer1.Enabled := true;
    ativo := false;
end;

procedure Tfrm_principal.grid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
 { if not odd(tab_eventos.RecNo) then // se for mpar
    if not (gdSelected in State) then // se a clula no est selecionada
    begin
      grid1.Canvas.Brush.Color := $00FFEFDF; // define uma cor de fundo
      grid1.Canvas.FillRect(Rect); // pinta a clula
      grid1.DefaultDrawDataCell(rect,Column.Field,State); // pinta o texto padro
    end;

   if tab_eventosData.Value = date then
   begin
      grid1.Canvas.Brush.Color := clRed; // define uma cor de fundo
      grid1.Canvas.FillRect(Rect); // pinta a clula
      grid1.DefaultDrawDataCell(rect,Column.Field,State); // pinta o texto padro
   end;
   //Falta 1 dia
   if tab_eventosData.Value = date+1 then
   begin
      grid1.Canvas.Brush.Color := $0041B0ED; // define uma cor de fundo
      grid1.Canvas.FillRect(Rect); // pinta a clula
      grid1.DefaultDrawDataCell(rect,Column.Field,State); // pinta o texto padro
   end;   }
end;

procedure Tfrm_principal.FormShow(Sender: TObject);
begin
  //label_cont.Caption := intToStr(tab_eventos.recordcount);


   application.Minimize;
  //Bloco MEMO
   frm_memo.show;
   //Esconde da barra
  tIcon.HideTaskbarIcon;
end;

procedure Tfrm_principal.timerMemoriaTimer(Sender: TObject);
var
  MemoryStatus: TMemoryStatus;
  memoria : integer;
begin
  MemoryStatus.dwLength:= sizeof(MemoryStatus);
  GlobalMemoryStatus(MemoryStatus);
  memoria := MemoryStatus.dwMemoryLoad;
  label_memoria.Caption := inttostr (memoria);
  label_memoria.Caption := label_memoria.Caption;
  pbar_memoria.Position := memoria;

  if memoria <= 29 then pbar_memoria.ColorElement := clLime;
  if ((memoria > 29) and (memoria <= 35)) then pbar_memoria.ColorElement := $0044FDBC;
  if ((memoria > 35) and (memoria <= 60)) then pbar_memoria.ColorElement := $000080FF;
  if ((memoria > 60) and (memoria <= 90)) then pbar_memoria.ColorElement := clred;
end;

procedure Tfrm_principal.fbCalClick(Sender: TObject);
begin
  calendario.Visible := true;
  frm_principal.AlphaBlendValue := 255;
  Timer_alpha.Enabled := true;
end;

procedure Tfrm_principal.fsbMenClick(Sender: TObject);
begin
   calendario.Visible := false;
   frm_principal.AlphaBlendValue := 255;
   Timer_alpha.Enabled := true;
end;

procedure Tfrm_principal.Timer_alphaTimer(Sender: TObject);
begin
 if ativo = false then
 begin
    frm_principal.AlphaBlendValue := 130;
    Timer_alpha.Enabled := false;
  end;
end;

procedure Tfrm_principal.grid1CellClick(Column: TColumn);
begin
   frm_principal.AlphaBlendValue := 255;
   Timer_alpha.Enabled := true;
end;

procedure Tfrm_principal.DBNavigator1Click(Sender: TObject;
  Button: TNavigateBtn);
begin
  frm_principal.AlphaBlendValue := 255;
   Timer_alpha.Enabled := true;
end;

procedure Tfrm_principal.Sair1Click(Sender: TObject);
begin
  ticon.MinimizeToTray := false;
  frm_principal.Close;  
end;

procedure Tfrm_principal.TIconClick(Sender: TObject);
begin
  TIcon.PopupAtCursor;
end;

procedure Tfrm_principal.fb_ativoClick(Sender: TObject);
begin
  ativo := true;
  fb_ativo.Color := clGreen;
  fb_inativo.Color := clBtnFace;
  calendario.Visible := true;
  frm_principal.AlphaBlendValue := 255;
end;

procedure Tfrm_principal.fb_inativoClick(Sender: TObject);
begin
  ativo := false;
  fb_ativo.Color := clBtnFace;
  fb_inativo.Color := clred;
  calendario.Visible := true;
  frm_principal.AlphaBlendValue := 130;
end;

procedure Tfrm_principal.CalendarioClick(Sender: TObject);
begin
    //Qry eventos no pode ser alterada devido ao campo descrio
    qry_eventos.Close;
    qry_eventos.SQL.Clear;
    qry_eventos.SQL.Add(
    'select           '+
'       dataevento Data,     '+
'       evento,           '+
'       descricao           '+
'     from                  '+
'      eventos              '+
'     where                  '+
'      dataevento = :diaCal');
    qry_eventos.ParamByName('diaCal').AsDate := (calendario.Date);
    qry_eventos.Open;
    //Add ao Hint a descricao
    grid1.Hint := memo_descricao.Lines.Text;

   //Interagindo...
   frm_principal.AlphaBlendValue := 255;
   Timer_alpha.Enabled := true;
end;

procedure Tfrm_principal.AddEvento1Click(Sender: TObject);
begin
 frm_addevento.edtAddData.Text := dateTostr(calendario.date);
  frm_addevento.showmodal;
end;


//------------------Pinta de Negrito------------------------------------------
procedure Tfrm_principal.CalendarioGetMonthInfo(Sender: TObject;
  Month: Cardinal; var MonthBoldInfo: Cardinal);
var
  dias : array[1..31] of integer;
  i : integer;
  Date: TDateTime;
  ano, mes, dia: Word;
begin
{    qry_eventos2.Close;
    qry_eventos2.SQL.Clear;
    qry_eventos2.SQL.Add(
    'select           '+
'       dataevento Data     '+
'     from                  '+
'      eventos');
    qry_eventos2.Open;
    i:= 1;

    repeat
        if qry_eventos2.Fields[0].Value <> null then
        begin
            DecodeDate(qry_eventos2.Fields[0].Value, ano, mes, dia);
            dias[i] := dia;
        end;
        i := i+1;
    until dias[i] > 0;

    
    i := 1;
    repeat
        Calendario.BoldDays( [dias[i]], MonthBoldInfo);
        i:= i+1;
    until dias[i] > 0    }
end;

//---------------------------------------------------------------------------

procedure Tfrm_principal.ExcluirEvento1Click(Sender: TObject);
begin
   qry_eventos2.Close;
    qry_eventos2.SQL.Clear;
    qry_eventos2.SQL.Add(
    'delete from eventos where dataevento = :data ');
    qry_eventos2.ParamByName('data').AsDate := (calendario.Date);
    qry_eventos2.execSQL;

end;

procedure Tfrm_principal.FlatButton1Click(Sender: TObject);
begin
qry_eventos.Close;
    qry_eventos.SQL.Clear;
    qry_eventos.SQL.Add(
    'select           '+
'       dataevento Data,     '+
'       evento,           '+
'       descricao           '+
'     from                  '+
'      eventos   '+
'     order by data ');
qry_eventos.Open;

end;

procedure Tfrm_principal.Alterardata1Click(Sender: TObject);
begin
  frm_alteradata.showmodal;
end;

procedure Tfrm_principal.FlatButton2Click(Sender: TObject);
begin
qry_eventos.Close;
    qry_eventos.SQL.Clear;
    qry_eventos.SQL.Add(
    'select           '+
'       dataevento Data,     '+
'       evento,           '+
'       descricao           '+
'     from                  '+
'      eventos   '+
'      where dataevento >= :datahj '+
'     order by data ');
qry_eventos.ParamByName('datahj').AsDate := date;
qry_eventos.Open;
end;

end.
